/*
 * DocServer
 * More Info available on https://www.doctag.de
 *
 * The version of the OpenAPI document: 0.1
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package de.doctag.docsrv_api.model;

import java.util.Objects;
import java.util.Arrays;
import java.util.Map;
import java.util.HashMap;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import de.doctag.docsrv_api.model.Signature;
import de.doctag.docsrv_api.model.Workflow;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.time.OffsetDateTime;
import java.util.ArrayList;
import java.util.List;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;


/**
 * Document
 */
@JsonPropertyOrder({
  Document.JSON_PROPERTY_ID,
  Document.JSON_PROPERTY_ATTACHMENT_HASH,
  Document.JSON_PROPERTY_ATTACHMENT_ID,
  Document.JSON_PROPERTY_CREATED,
  Document.JSON_PROPERTY_FULL_TEXT,
  Document.JSON_PROPERTY_IS_MIRRORED,
  Document.JSON_PROPERTY_MIRRORS,
  Document.JSON_PROPERTY_ORIGINAL_FILE_NAME,
  Document.JSON_PROPERTY_SIGNATURES,
  Document.JSON_PROPERTY_URL,
  Document.JSON_PROPERTY_WORKFLOW
})
@javax.annotation.processing.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen")
public class Document {
  public static final String JSON_PROPERTY_ID = "_id";
  private String id;

  public static final String JSON_PROPERTY_ATTACHMENT_HASH = "attachmentHash";
  private String attachmentHash;

  public static final String JSON_PROPERTY_ATTACHMENT_ID = "attachmentId";
  private String attachmentId;

  public static final String JSON_PROPERTY_CREATED = "created";
  private OffsetDateTime created;

  public static final String JSON_PROPERTY_FULL_TEXT = "fullText";
  private String fullText;

  public static final String JSON_PROPERTY_IS_MIRRORED = "isMirrored";
  private Boolean isMirrored;

  public static final String JSON_PROPERTY_MIRRORS = "mirrors";
  private List<String> mirrors = null;

  public static final String JSON_PROPERTY_ORIGINAL_FILE_NAME = "originalFileName";
  private String originalFileName;

  public static final String JSON_PROPERTY_SIGNATURES = "signatures";
  private List<Signature> signatures = null;

  public static final String JSON_PROPERTY_URL = "url";
  private String url;

  public static final String JSON_PROPERTY_WORKFLOW = "workflow";
  private Workflow workflow;


  public Document id(String id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getId() {
    return id;
  }


  @JsonProperty(JSON_PROPERTY_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setId(String id) {
    this.id = id;
  }


  public Document attachmentHash(String attachmentHash) {
    this.attachmentHash = attachmentHash;
    return this;
  }

   /**
   * Get attachmentHash
   * @return attachmentHash
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_ATTACHMENT_HASH)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getAttachmentHash() {
    return attachmentHash;
  }


  @JsonProperty(JSON_PROPERTY_ATTACHMENT_HASH)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setAttachmentHash(String attachmentHash) {
    this.attachmentHash = attachmentHash;
  }


  public Document attachmentId(String attachmentId) {
    this.attachmentId = attachmentId;
    return this;
  }

   /**
   * Get attachmentId
   * @return attachmentId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_ATTACHMENT_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getAttachmentId() {
    return attachmentId;
  }


  @JsonProperty(JSON_PROPERTY_ATTACHMENT_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setAttachmentId(String attachmentId) {
    this.attachmentId = attachmentId;
  }


  public Document created(OffsetDateTime created) {
    this.created = created;
    return this;
  }

   /**
   * Get created
   * @return created
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_CREATED)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public OffsetDateTime getCreated() {
    return created;
  }


  @JsonProperty(JSON_PROPERTY_CREATED)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setCreated(OffsetDateTime created) {
    this.created = created;
  }


  public Document fullText(String fullText) {
    this.fullText = fullText;
    return this;
  }

   /**
   * Get fullText
   * @return fullText
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_FULL_TEXT)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getFullText() {
    return fullText;
  }


  @JsonProperty(JSON_PROPERTY_FULL_TEXT)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setFullText(String fullText) {
    this.fullText = fullText;
  }


  public Document isMirrored(Boolean isMirrored) {
    this.isMirrored = isMirrored;
    return this;
  }

   /**
   * Get isMirrored
   * @return isMirrored
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_IS_MIRRORED)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Boolean getIsMirrored() {
    return isMirrored;
  }


  @JsonProperty(JSON_PROPERTY_IS_MIRRORED)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setIsMirrored(Boolean isMirrored) {
    this.isMirrored = isMirrored;
  }


  public Document mirrors(List<String> mirrors) {
    this.mirrors = mirrors;
    return this;
  }

  public Document addMirrorsItem(String mirrorsItem) {
    if (this.mirrors == null) {
      this.mirrors = new ArrayList<>();
    }
    this.mirrors.add(mirrorsItem);
    return this;
  }

   /**
   * Get mirrors
   * @return mirrors
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_MIRRORS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<String> getMirrors() {
    return mirrors;
  }


  @JsonProperty(JSON_PROPERTY_MIRRORS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setMirrors(List<String> mirrors) {
    this.mirrors = mirrors;
  }


  public Document originalFileName(String originalFileName) {
    this.originalFileName = originalFileName;
    return this;
  }

   /**
   * Get originalFileName
   * @return originalFileName
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_ORIGINAL_FILE_NAME)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getOriginalFileName() {
    return originalFileName;
  }


  @JsonProperty(JSON_PROPERTY_ORIGINAL_FILE_NAME)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setOriginalFileName(String originalFileName) {
    this.originalFileName = originalFileName;
  }


  public Document signatures(List<Signature> signatures) {
    this.signatures = signatures;
    return this;
  }

  public Document addSignaturesItem(Signature signaturesItem) {
    if (this.signatures == null) {
      this.signatures = new ArrayList<>();
    }
    this.signatures.add(signaturesItem);
    return this;
  }

   /**
   * Get signatures
   * @return signatures
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_SIGNATURES)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<Signature> getSignatures() {
    return signatures;
  }


  @JsonProperty(JSON_PROPERTY_SIGNATURES)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setSignatures(List<Signature> signatures) {
    this.signatures = signatures;
  }


  public Document url(String url) {
    this.url = url;
    return this;
  }

   /**
   * Get url
   * @return url
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_URL)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getUrl() {
    return url;
  }


  @JsonProperty(JSON_PROPERTY_URL)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setUrl(String url) {
    this.url = url;
  }


  public Document workflow(Workflow workflow) {
    this.workflow = workflow;
    return this;
  }

   /**
   * Get workflow
   * @return workflow
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_WORKFLOW)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Workflow getWorkflow() {
    return workflow;
  }


  @JsonProperty(JSON_PROPERTY_WORKFLOW)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setWorkflow(Workflow workflow) {
    this.workflow = workflow;
  }


  /**
   * Return true if this Document object is equal to o.
   */
  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Document document = (Document) o;
    return Objects.equals(this.id, document.id) &&
        Objects.equals(this.attachmentHash, document.attachmentHash) &&
        Objects.equals(this.attachmentId, document.attachmentId) &&
        Objects.equals(this.created, document.created) &&
        Objects.equals(this.fullText, document.fullText) &&
        Objects.equals(this.isMirrored, document.isMirrored) &&
        Objects.equals(this.mirrors, document.mirrors) &&
        Objects.equals(this.originalFileName, document.originalFileName) &&
        Objects.equals(this.signatures, document.signatures) &&
        Objects.equals(this.url, document.url) &&
        Objects.equals(this.workflow, document.workflow);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, attachmentHash, attachmentId, created, fullText, isMirrored, mirrors, originalFileName, signatures, url, workflow);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Document {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    attachmentHash: ").append(toIndentedString(attachmentHash)).append("\n");
    sb.append("    attachmentId: ").append(toIndentedString(attachmentId)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    fullText: ").append(toIndentedString(fullText)).append("\n");
    sb.append("    isMirrored: ").append(toIndentedString(isMirrored)).append("\n");
    sb.append("    mirrors: ").append(toIndentedString(mirrors)).append("\n");
    sb.append("    originalFileName: ").append(toIndentedString(originalFileName)).append("\n");
    sb.append("    signatures: ").append(toIndentedString(signatures)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    workflow: ").append(toIndentedString(workflow)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

